package pl.labno.bernard.nbp.exchangerate.rest;

import org.apache.commons.io.IOUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.labno.bernard.nbp.exchangerate.rest.generated.ExchangeRateTable;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringReader;
import java.net.URL;

public class ExchangeRateTableUnmarshaller {

    private static final Log LOG = LogFactory.getLog(ExchangeRateTableUnmarshaller.class);

    public static ExchangeRateTable unmarshal(String url) throws JAXBException, IOException {
        return unmarshal(new URL(url).openStream());
    }

    public static ExchangeRateTable unmarshal(InputStream stream) throws JAXBException, IOException {
        return unmarshal(new InputStreamReader(stream));
    }

    public static ExchangeRateTable unmarshal(Reader reader) throws JAXBException, IOException {
        String content = IOUtils.toString(reader);
        try {
            JAXBContext jaxbContext = JAXBContext.newInstance(ExchangeRateTable.class.getPackage().getName());
            return (ExchangeRateTable) jaxbContext.createUnmarshaller().unmarshal(new StringReader(content));
        } catch (JAXBException e) {
            LOG.error("Cannot unmarshal input stream.\n" + content, e);
            throw e;
        }
    }

}
